import ReactDOM from 'react-dom';
import React from 'react';
import PropTypes from 'prop-types';
import CoreApp from 'fusion-core';
import { prepare, PreparePlugin } from 'fusion-react-async';

/** Copyright (c) 2018 Uber Technologies, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

/* eslint-env node */

/** Copyright (c) 2018 Uber Technologies, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

/* eslint-env browser */
var clientRender = (function (el) {
  var domElement = document.getElementById('root');
  return ReactDOM.hydrate ? ReactDOM.hydrate(el, domElement) : ReactDOM.render(el, domElement);
});

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

/** Copyright (c) 2018 Uber Technologies, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var Provider = {
  create: function create(name) {
    var _Object$assign;

    var Provider =
    /*#__PURE__*/
    function (_React$Component) {
      _inheritsLoose(Provider, _React$Component);

      function Provider() {
        return _React$Component.apply(this, arguments) || this;
      }

      var _proto = Provider.prototype;

      _proto.getChildContext = function getChildContext() {
        var _ref;

        return _ref = {}, _ref[name] = this.props.provides, _ref;
      };

      _proto.render = function render() {
        return React.Children.only(this.props.children);
      };

      return Provider;
    }(React.Component);

    Provider.childContextTypes = Object.assign({}, Provider.childContextTypes || {}, (_Object$assign = {}, _Object$assign[name] = PropTypes.any.isRequired, _Object$assign));
    Provider.displayName = name.replace(/^./, function (c) {
      return c.toUpperCase();
    }) + 'Provider';
    return Provider;
  }
};

/** Copyright (c) 2018 Uber Technologies, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var plugin = {
  create: function create(name, plugin, provider) {
    var originalMiddleware = plugin.middleware;
    var ProviderComponent = provider || Provider.create(name);

    plugin.middleware = function (deps, provides) {
      if (originalMiddleware) {
        originalMiddleware = originalMiddleware(deps, provides);
      }

      return function (ctx, next) {
        if (ctx.element) {
          ctx.element = React.createElement(ProviderComponent, {
            provides: provides,
            ctx: ctx
          }, ctx.element);
        }

        if (originalMiddleware) {
          return originalMiddleware(ctx, next);
        }

        return next();
      };
    };

    return plugin;
  }
};

function _inheritsLoose$1(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

/** Copyright (c) 2018 Uber Technologies, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var hoc = {
  create: function create(name, mapProvidesToProps) {
    if (!mapProvidesToProps) {
      mapProvidesToProps = function mapProvidesToProps(provides) {
        var _ref;

        return _ref = {}, _ref[name] = provides, _ref;
      };
    }

    return function (Component) {
      var _HOC$contextTypes;

      var HOC =
      /*#__PURE__*/
      function (_React$Component) {
        _inheritsLoose$1(HOC, _React$Component);

        function HOC(props, ctx) {
          var _this;

          _this = _React$Component.call(this, props, ctx) || this;
          _this.provides = ctx[name];
          return _this;
        }

        var _proto = HOC.prototype;

        _proto.render = function render() {
          var props = Object.assign({}, this.props, mapProvidesToProps(this.provides));
          return React.createElement(Component, props);
        };

        return HOC;
      }(React.Component);

      var displayName = Component.displayName || Component.name;
      HOC.displayName = 'With' + name.replace(/^./, function (c) {
        return c.toUpperCase();
      }) + '(' + displayName + ')';
      HOC.contextTypes = (_HOC$contextTypes = {}, _HOC$contextTypes[name] = PropTypes.any.isRequired, _HOC$contextTypes);
      return HOC;
    };
  }
};

function _inheritsLoose$2(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

/** Copyright (c) 2018 Uber Technologies, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

/* eslint-env browser */
var App =
/*#__PURE__*/
function (_CoreApp) {
  _inheritsLoose$2(App, _CoreApp);

  function App(root, render) {
    var _this;

    _this = _CoreApp.call(this, root, function (el) {
      return prepare(el).then(function () {
        if (render) {
          return render(el);
        }

        return clientRender(el);
      });
    }) || this;

    _this.middleware(PreparePlugin());

    return _this;
  }

  return App;
}(CoreApp);

export default App;
export { plugin as ProviderPlugin, hoc as ProvidedHOC, Provider };
//# sourceMappingURL=browser.es5.es.js.map
